Results 1 to 5 of 5

Thread: additional Object Snap options

  1. #1
    Wish List Administration
    Join Date
    2011-08
    Posts
    4,581

    Default additional Object Snap options

    Summary: Enhancement to object snap functionality that would add two new options to improve productivity.

    Description: In future releases of AutoCAD and related vertical applications, I would like to see an object snap option added to snap to the Centroid of any closed shape, including closed polylines, boundaries, regions, hatches, etc.

    Another valuable snapping option (not sure what to call it) would be one that would snap to proportional locations along a line or arc object based on some division parameter set in the Osnap settings dialog box. For example, if you entered a value of 20 and made this option active, you could snap to positions 20, 40, 60, and 80% along the length of a line or arc.

    I believe both ideas could be implemented fairly easily.


    Product and Feature: AutoCAD - Snaps

    Submitted By: Michael Warren on 05/10/2013


  2. #2
    Member
    Join Date
    2011-05
    Posts
    23

    Lightbulb Re: additional Object Snap options

    You can create your own OSNAPS like the proportional one by using (C:CAL).

    Transparently you would use this:
    Code:
    'cal (cur+cur)/2
    You have to pick 2 points, and it will return the mid point. You could create a toolbar flyout with 1/3, 1/2, 2/3, etc for quick access.

    It's not exactly what you want. And it won't work on Arcs, but with some programming, you could get it to work. Which just means that Autodesk could make it work as well, probably much easier...

  3. #3
    Certifiable AUGI Addict
    Join Date
    2001-03
    Location
    Tallahassee, FL USA
    Posts
    3,658

    Default Re: additional Object Snap options

    To snap proportional along a line try: http://forums.augi.com/showthread.ph...icrostation#16
    For middle of an object:
    Code:
     ; Middle Object Osnap
    ; Macro: ^P(or midobj (load "midobj.lsp")(princ))(midobj) 
    (defun midobj (/ ll ur selection pntlist pnts adoc)
      (setq selection (car (entsel))
              adoc   (vla-get-activedocument (vlax-get-acad-object))
      )
      (vla-getboundingbox (vlax-ename->vla-object selection) 'll 'ur)
      (setq pntlist  (mapcar 'vlax-safearray->list (list ll ur)))
      (list(/(+(caar pntlist)(caadr pntlist))2.0)(/(+(cadar pntlist)(cadadr pntlist))2.0))
    )
    For Centroid of closed polygon try:
    Code:
    ;Center of closed polygon
    ;^P(or C:pc1 (load "pc1.lsp"))(pc1)
    ; (load "pc1.lsp")(pc1)
    (defun pc1 ( / acdoc acspc acsel reg pt) (vl-load-com) ;; © Lee Mac 2011
    
      (setq acdoc (vla-get-ActiveDocument (vlax-get-acad-object))
            acspc (vlax-get-property acdoc (if (= 1 (getvar 'CVPORT)) 'Paperspace 'Modelspace))
      )
    ;  (if (ssget "+.:E:S")
      (if (ssget "+.:E:S" '((0 . "LWPOLYLINE") (-4 . "&=") (70 . 1)))
        (progn
          (vlax-for obj (setq acsel (vla-get-ActiveSelectionSet acdoc))
            (setq pt(trans (vlax-get (setq reg (car (vlax-invoke acspc 'addregion (list obj)))) 'Centroid) 1 0))
            (vla-delete reg)
          )
          (vla-delete acsel)
        )
      )
      pt
    )

  4. #4
    Active Member
    Join Date
    2013-03
    Location
    Can you say DERECHO, Iowa
    Posts
    66

    Default Re: additional Object Snap options

    Quote Originally Posted by Wish List System View Post
    Another valuable snapping option (not sure what to call it) would be one that would snap to proportional locations along a line or arc object based on some division parameter set in the Osnap settings dialog box. For example, if you entered a value of 20 and made this option active, you could snap to positions 20, 40, 60, and 80% along the length of a line or arc.
    This one shouldn't be hard for them to add, as we already have similar options within dynamic blocks.

  5. #5
    Wish List Administration
    Join Date
    2011-08
    Posts
    4,581

    Exclamation Re: additional Object Snap options

    The wish has already been granted. This thread is closed to further posts.

Similar Threads

  1. Additional LWPolyline editing options
    By Wish List System in forum AutoCAD Wish List
    Replies: 0
    Last Post: 2012-12-19, 07:22 PM
  2. View Templates with additional options....
    By AJGKennedy in forum Revit Architecture - General
    Replies: 0
    Last Post: 2008-07-31, 09:06 PM
  3. Additional Data options for Survey Points
    By civil3d.wishlist1941 in forum Civil 3D Wish List
    Replies: 1
    Last Post: 2008-05-01, 06:27 PM
  4. Additional FIELD Options for 3DSolids
    By autocad.wishlist1734 in forum AutoCAD Wish List
    Replies: 0
    Last Post: 2007-05-26, 06:40 PM
  5. ADDITIONAL OSNAP Options
    By jasontirone in forum AutoCAD General
    Replies: 0
    Last Post: 2005-02-07, 03:03 PM

Posting Permissions

  • You may not post new threads
  • You may not post replies
  • You may not post attachments
  • You may not edit your posts
  •